/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : Ӧϵͳʼ
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "CONFIG.h"
#include "HAL.h"
#include "hiddev.h"
#include "hidkbd.h"

#define DEBUG  1

/*********************************************************************
 * GLOBAL TYPEDEFS
 */
__attribute__((aligned(4))) uint32_t MEM_BUF[BLE_MEMHEAP_SIZE / 4];

__attribute__((aligned(4))) uint8_t RxBuffer[MAX_PACKET_SIZE]; // IN, must even address
__attribute__((aligned(4))) uint8_t TxBuffer[MAX_PACKET_SIZE]; // OUT, must even address
extern uint8_t need_send;



#if(defined(BLE_MAC)) && (BLE_MAC == TRUE)
const uint8_t MacAddr[6] = {0x84, 0xC2, 0xE4, 0x03, 0x02, 0x02};
#endif

/*********************************************************************
 * @fn      Main_Circulation
 *
 * @brief   ѭ
 *
 * @return  none
 */
__HIGH_CODE
__attribute__((noinline))   //Ϊ
void Main_Circulation()
{
//    while(1)
//    {
        TMOS_SystemProcess(); //tmosϵͳ,Ҫ
//    }
}

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main(void)
{
    uint8_t i, s, k, len, endp;
    uint16_t  loc;

#if(defined(DCDC_ENABLE)) && (DCDC_ENABLE == TRUE)
    PWR_DCDCCfg(ENABLE);
#endif
    SetSysClock(CLK_SOURCE_PLL_60MHz);
#if(defined(HAL_SLEEP)) && (HAL_SLEEP == TRUE)
    GPIOA_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
    GPIOB_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PU);
#endif
    /* ѹ */
    PowerMonitor(ENABLE, HALevel_2V1);
#ifdef DEBUG
    GPIOA_SetBits(bTXD1); //PA9
    GPIOA_ModeCfg(bRXD1, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(bTXD1, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
#endif
    PRINT("%s\n", VER_LIB);
    CH58X_BLEInit();
    HAL_Init();
    GAPRole_PeripheralInit();
    HidDev_Init();
    HidEmu_Init();

    PRINT("Start @ChipID=%02X\n", R8_CHIP_ID);

    pU2HOST_RX_RAM_Addr = RxBuffer;
    pU2HOST_TX_RAM_Addr = TxBuffer;
    USB2_HostInit();
    PRINT("Wait Device In...\n");


    while(1)
    {

        Main_Circulation();

        s = ERR_SUCCESS;
        if(R8_USB2_INT_FG & RB_UIF_DETECT)
        { // USBж
            R8_USB2_INT_FG = RB_UIF_DETECT;
            s = AnalyzeRootU2Hub();
            if(s == ERR_USB_CONNECT)
                FoundNewU2Dev = 1;
        }

        if(FoundNewU2Dev || s == ERR_USB_CONNECT)
        { // µUSB豸
            FoundNewU2Dev = 0;
            mDelaymS(200);          // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
            s = InitRootU2Device(); // ʼUSB豸
            if(s != ERR_SUCCESS)
            {
                PRINT("EnumAllRootDev err = %02X\n", (uint16_t)s);
            }
        }

        /* ¶ӵHUBöHUB */
        s = EnumAllU2HubPort(); // öROOT-HUB˿ⲿHUBĶUSB豸
        if(s != ERR_SUCCESS)
        { // HUBϿ
            PRINT("EnumAllHubPort err = %02X\n", (uint16_t)s);
        }

        /* 豸Ǽ */
        loc = U2SearchTypeDevice(DEV_TYPE_KEYBOARD); // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
        if(loc != 0xFFFF)
        { // ҵ,KeyBoardδ?
            i = (uint8_t)(loc >> 8);
            len = (uint8_t)loc;
            SelectU2HubPort(len);                                                 // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
            endp = len ? DevOnU2HubPort[len - 1].GpVar[0] : ThisUsb2Dev.GpVar[0]; // ж϶˵ĵַ,λ7ͬ־λ
            if(endp & USB_ENDP_ADDR_MASK)
            {                                                                                                        // ˵Ч
                s = USB2HostTransact(USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0); // ,ȡ,NAK
                if(s == ERR_SUCCESS)
                {
                    endp ^= 0x80; // ͬ־ת
                    if(len)
                        DevOnU2HubPort[len - 1].GpVar[0] = endp; // ͬ־λ
                    else
                        ThisUsb2Dev.GpVar[0] = endp;
                    len = R8_USB2_RX_LEN; // յݳ
                    if(len)
                    {
                        U2SETorOFFNumLock(RxBuffer);

                        PRINT("keyboard data: ");
                        for(i = 0; i < len; i++)
                        {
                            PRINT("x%02X ", (uint16_t)(RxBuffer[i]));
                        }
                        PRINT("\n");
                        need_send = 1;
                    }
                }
                else if(s != (USB_PID_NAK | ERR_USB_TRANSFER))
                {
                    PRINT("keyboard error %02x\n", (uint16_t)s); // ǶϿ
                }
            }
            else
            {
                PRINT("keyboard no interrupt endpoint\n");
            }
            SetUsb2Speed(1); // ĬΪȫ
        }
    }
}

/******************************** endfile @ main ******************************/
